Index: issm/trunk/test/NightlyRun/test248.m
===================================================================
--- issm/trunk/test/NightlyRun/test248.m	(revision 8392)
+++ issm/trunk/test/NightlyRun/test248.m	(revision 8433)
@@ -6,5 +6,5 @@
 md=SetParallel(md,3);
 md.hydrostatic_adjustment=IncrementalEnum;
-md=solve(md,Transient3DSolutionEnum);
+md=solve(md,TransientSolutionEnum);
 
 %Fields and tolerances to track changes
@@ -17,33 +17,33 @@
 	1e-09,1e-09,1e-08,1e-08,1e-09,1e-09,1e-09,1e-09,1e-09,1e-05};
 field_values={...
-	PatchToVec(md.results.Transient3DSolution(1).Vx),...
-	PatchToVec(md.results.Transient3DSolution(1).Vy),...
-	PatchToVec(md.results.Transient3DSolution(1).Vz),...
-	PatchToVec(md.results.Transient3DSolution(1).Vel),...
-	PatchToVec(md.results.Transient3DSolution(1).Pressure),...
-	PatchToVec(md.results.Transient3DSolution(1).Bed),...
-	PatchToVec(md.results.Transient3DSolution(1).Surface),...
-	PatchToVec(md.results.Transient3DSolution(1).Thickness),...
-	PatchToVec(md.results.Transient3DSolution(1).Temperature),...
-	PatchToVec(md.results.Transient3DSolution(1).BasalMeltingRate),...
-	PatchToVec(md.results.Transient3DSolution(2).Vx),...
-	PatchToVec(md.results.Transient3DSolution(2).Vy),...
-	PatchToVec(md.results.Transient3DSolution(2).Vz),...
-	PatchToVec(md.results.Transient3DSolution(2).Vel),...
-	PatchToVec(md.results.Transient3DSolution(2).Pressure),...
-	PatchToVec(md.results.Transient3DSolution(2).Bed),...
-	PatchToVec(md.results.Transient3DSolution(2).Surface),...
-	PatchToVec(md.results.Transient3DSolution(2).Thickness),...
-	PatchToVec(md.results.Transient3DSolution(2).Temperature),...
-	PatchToVec(md.results.Transient3DSolution(2).BasalMeltingRate),...
-	PatchToVec(md.results.Transient3DSolution(3).Vx),...
-	PatchToVec(md.results.Transient3DSolution(3).Vy),...
-	PatchToVec(md.results.Transient3DSolution(3).Vz),...
-	PatchToVec(md.results.Transient3DSolution(3).Vel),...
-	PatchToVec(md.results.Transient3DSolution(3).Pressure),...
-	PatchToVec(md.results.Transient3DSolution(3).Bed),...
-	PatchToVec(md.results.Transient3DSolution(3).Surface),...
-	PatchToVec(md.results.Transient3DSolution(3).Thickness),...
-	PatchToVec(md.results.Transient3DSolution(3).Temperature),...
-	PatchToVec(md.results.Transient3DSolution(3).BasalMeltingRate),...
+	PatchToVec(md.results.TransientSolution(1).Vx),...
+	PatchToVec(md.results.TransientSolution(1).Vy),...
+	PatchToVec(md.results.TransientSolution(1).Vz),...
+	PatchToVec(md.results.TransientSolution(1).Vel),...
+	PatchToVec(md.results.TransientSolution(1).Pressure),...
+	PatchToVec(md.results.TransientSolution(1).Bed),...
+	PatchToVec(md.results.TransientSolution(1).Surface),...
+	PatchToVec(md.results.TransientSolution(1).Thickness),...
+	PatchToVec(md.results.TransientSolution(1).Temperature),...
+	PatchToVec(md.results.TransientSolution(1).BasalMeltingRate),...
+	PatchToVec(md.results.TransientSolution(2).Vx),...
+	PatchToVec(md.results.TransientSolution(2).Vy),...
+	PatchToVec(md.results.TransientSolution(2).Vz),...
+	PatchToVec(md.results.TransientSolution(2).Vel),...
+	PatchToVec(md.results.TransientSolution(2).Pressure),...
+	PatchToVec(md.results.TransientSolution(2).Bed),...
+	PatchToVec(md.results.TransientSolution(2).Surface),...
+	PatchToVec(md.results.TransientSolution(2).Thickness),...
+	PatchToVec(md.results.TransientSolution(2).Temperature),...
+	PatchToVec(md.results.TransientSolution(2).BasalMeltingRate),...
+	PatchToVec(md.results.TransientSolution(3).Vx),...
+	PatchToVec(md.results.TransientSolution(3).Vy),...
+	PatchToVec(md.results.TransientSolution(3).Vz),...
+	PatchToVec(md.results.TransientSolution(3).Vel),...
+	PatchToVec(md.results.TransientSolution(3).Pressure),...
+	PatchToVec(md.results.TransientSolution(3).Bed),...
+	PatchToVec(md.results.TransientSolution(3).Surface),...
+	PatchToVec(md.results.TransientSolution(3).Thickness),...
+	PatchToVec(md.results.TransientSolution(3).Temperature),...
+	PatchToVec(md.results.TransientSolution(3).BasalMeltingRate),...
 	};