Index: issm/trunk/src/m/model/loadresultsfromcluster.m
===================================================================
--- issm/trunk/src/m/model/loadresultsfromcluster.m	(revision 8576)
+++ issm/trunk/src/m/model/loadresultsfromcluster.m	(revision 8577)
@@ -37,6 +37,6 @@
 %erase the log and output files
 if md.qmu_analysis,
-	delete([['qmu' num2str(GetPId) '/'] md.name '.outlog']);
-	delete([['qmu' num2str(GetPId) '/']  md.name '.errlog']);
+	delete([['qmu' num2str(feature('GetPid')) '/'] md.name '.outlog']);
+	delete([['qmu' num2str(feature('GetPid')) '/']  md.name '.errlog']);
 else
 	delete([md.name '.outlog']);
@@ -50,6 +50,6 @@
 if strcmpi(hostname,cluster.name),
 	if md.qmu_analysis,
-		delete([['qmu' num2str(GetPId) '/'] md.name '.bin']);
-		delete([['qmu' num2str(GetPId) '/'] md.name '.queue']);
+		delete([['qmu' num2str(feature('GetPid')) '/'] md.name '.bin']);
+		delete([['qmu' num2str(feature('GetPid')) '/'] md.name '.queue']);
 	else
 		delete([md.name '.bin']);
Index: issm/trunk/src/m/model/parameterization/parameterize.m
===================================================================
--- issm/trunk/src/m/model/parameterization/parameterize.m	(revision 8576)
+++ issm/trunk/src/m/model/parameterization/parameterize.m	(revision 8577)
@@ -33,5 +33,5 @@
 
 %Try and run parameter file.
-temporaryname=['TemporaryParameterFile' num2str(GetPId()) ];
+temporaryname=['TemporaryParameterFile' num2str(feature('GetPid')) ];
 copyfile(parametername,[temporaryname '.m']);
 
Index: issm/trunk/src/m/model/plot/processdata.m
===================================================================
--- issm/trunk/src/m/model/plot/processdata.m	(revision 8576)
+++ issm/trunk/src/m/model/plot/processdata.m	(revision 8577)
@@ -183,2 +183,7 @@
 	clear databak
 end
+
+%OK, if datatype=0 error out
+if datatype==0,
+	error(['data provided not recognized or not supported']);
+end
Index: issm/trunk/src/m/model/process_solve_options.m
===================================================================
--- issm/trunk/src/m/model/process_solve_options.m	(revision 8576)
+++ issm/trunk/src/m/model/process_solve_options.m	(revision 8577)
@@ -22,5 +22,5 @@
 
 %  process qmu arguments
-outoptions.qmudir=getfieldvalue(options,'qmudir',['qmu' num2str(GetPId)]);  % qmudir =['qmu_' datestr(now,'yyyymmdd_HHMMSS')];
+outoptions.qmudir=getfieldvalue(options,'qmudir',['qmu' num2str(feature('GetPid'))]);  % qmudir =['qmu_' datestr(now,'yyyymmdd_HHMMSS')];
 outoptions.qmufile=getfieldvalue(options,'qmufile','qmu');% qmufile cannot be changed unless ????script.sh is also changed
 outoptions.overwrite=getfieldvalue(options,'overwrite','n');
@@ -33,5 +33,5 @@
 
 %  process flaim arguments
-outoptions.fmdir=getfieldvalue(options,'fmdir',['fm' num2str(GetPId)]);
+outoptions.fmdir=getfieldvalue(options,'fmdir',['fm' num2str(feature('GetPid'))]);
 outoptions.fmfile=getfieldvalue(options,'fmfile','fm_targets');
 outoptions.overwrite=getfieldvalue(options,'overwrite','n');
Index: issm/trunk/src/m/model/solve.m
===================================================================
--- issm/trunk/src/m/model/solve.m	(revision 8576)
+++ issm/trunk/src/m/model/solve.m	(revision 8577)
@@ -82,5 +82,5 @@
 	cd ..
 	if ~strncmpi(options.keep,'y',1)
-		system(['rm -rf qmu' num2str(GetPId)]);
+		system(['rm -rf qmu' num2str(feature('GetPid'))]);
 	end
 end
Index: issm/trunk/src/m/model/solveparallel.m
===================================================================
--- issm/trunk/src/m/model/solveparallel.m	(revision 8576)
+++ issm/trunk/src/m/model/solveparallel.m	(revision 8577)
@@ -12,5 +12,5 @@
 	%First, build a runtime name that is unique, that we will use to create 
 	%directories, name jobs, etc ...
-	c=clock; md.runtimename=sprintf('%s-%i-%i-%i-%i-%i-%i-%i',md.name,c(2),c(3),c(1),c(4),c(5),floor(c(6)),GetPId());
+	c=clock; md.runtimename=sprintf('%s-%i-%i-%i-%i-%i-%i-%i',md.name,c(2),c(3),c(1),c(4),c(5),floor(c(6)),feature('GetPid'));
 
 	%Now, we need to build the queuing script, used by the cluster to launch the job.
@@ -39,5 +39,5 @@
 		if md.qmu_analysis,
 			if ~strncmpi(options.keep,'y',1)
-				system(['rm -rf qmu' num2str(GetPId)]);
+				system(['rm -rf qmu' num2str(feature('GetPid'))]);
 			end
 		end