Index: issm/trunk/test/NightlyRun/test255.m
===================================================================
--- issm/trunk/test/NightlyRun/test255.m	(revision 8785)
+++ issm/trunk/test/NightlyRun/test255.m	(revision 8790)
@@ -7,5 +7,5 @@
 md.dt=1;
 md.output_frequency=1;
-md.ndt=3;
+md.ndt=4;
 
 %Set up transient
@@ -14,5 +14,5 @@
 
 md.forcings.surface_mass_balance= smb;
-md.forcings.surface_mass_balance(end+1,:)=[1 3];
+md.forcings.surface_mass_balance(end+1,:)=[1.5 3];
 md.isthermal=0;
 
@@ -21,9 +21,12 @@
 %Fields and tolerances to track changes
 field_names={'Vx1','Vy1','Vel1','Pressure1','Bed1','Surface1','Thickness1','SurfaceMassBalance1', ...
-	          'Vx2','Vy2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
-	          'Vx3','Vy3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3'};
-field_tolerances={1e-09,1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,...
-	                  1e-09,1e-09,1e-10,1e-09,1e-10,1e-10,1e-10,1e-10,...
-	                  1e-09,5e-10,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10};
+	'Vx2','Vy2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
+	'Vx3','Vy3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3', ...
+	'Vx4','Vy4','Vel4','Pressure4','Bed4','Surface4','Thickness4','SurfaceMassBalance4'};
+field_tolerances={1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,...
+	1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,...
+	1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,...
+	1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10};
+
 field_values={...
 	PatchToVec(md.results.TransientSolution(1).Vx),...
@@ -51,3 +54,11 @@
 	PatchToVec(md.results.TransientSolution(3).Thickness),...
 	PatchToVec(md.results.TransientSolution(3).SurfaceMassBalance),...
+	PatchToVec(md.results.TransientSolution(4).Vx),...
+	PatchToVec(md.results.TransientSolution(4).Vy),...
+	PatchToVec(md.results.TransientSolution(4).Vel),...
+	PatchToVec(md.results.TransientSolution(4).Pressure),...
+	PatchToVec(md.results.TransientSolution(4).Bed),...
+	PatchToVec(md.results.TransientSolution(4).Surface),...
+	PatchToVec(md.results.TransientSolution(4).Thickness),...
+	PatchToVec(md.results.TransientSolution(4).SurfaceMassBalance),...
 	};
Index: issm/trunk/test/NightlyRun/test256.m
===================================================================
--- issm/trunk/test/NightlyRun/test256.m	(revision 8785)
+++ issm/trunk/test/NightlyRun/test256.m	(revision 8790)
@@ -7,5 +7,5 @@
 md.dt=1;
 md.output_frequency=1;
-md.ndt=3;
+md.ndt=4;
 
 %Set up transient
@@ -14,5 +14,5 @@
 
 md.forcings.surface_mass_balance= smb;
-md.forcings.surface_mass_balance(end+1,:)=[1 3];
+md.forcings.surface_mass_balance(end+1,:)=[1.5 3];
 md.isthermal=0;
 
@@ -21,9 +21,12 @@
 %Fields and tolerances to track changes
 field_names={'Vx1','Vy1','Vel1','Pressure1','Bed1','Surface1','Thickness1','SurfaceMassBalance1', ...
-	          'Vx2','Vy2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
-	          'Vx3','Vy3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3'};
-field_tolerances={1e-09,1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,...
-	                  1e-09,1e-09,1e-10,1e-09,1e-10,1e-10,1e-10,1e-10,...
-	                  1e-09,5e-10,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10};
+	'Vx2','Vy2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
+	'Vx3','Vy3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3', ...
+	'Vx4','Vy4','Vel4','Pressure4','Bed4','Surface4','Thickness4','SurfaceMassBalance4'};
+field_tolerances={1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,...
+	1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,...
+	1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,...
+	1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10};
+
 field_values={...
 	PatchToVec(md.results.TransientSolution(1).Vx),...
@@ -51,3 +54,11 @@
 	PatchToVec(md.results.TransientSolution(3).Thickness),...
 	PatchToVec(md.results.TransientSolution(3).SurfaceMassBalance),...
+	PatchToVec(md.results.TransientSolution(4).Vx),...
+	PatchToVec(md.results.TransientSolution(4).Vy),...
+	PatchToVec(md.results.TransientSolution(4).Vel),...
+	PatchToVec(md.results.TransientSolution(4).Pressure),...
+	PatchToVec(md.results.TransientSolution(4).Bed),...
+	PatchToVec(md.results.TransientSolution(4).Surface),...
+	PatchToVec(md.results.TransientSolution(4).Thickness),...
+	PatchToVec(md.results.TransientSolution(4).SurfaceMassBalance),...
 	};
Index: issm/trunk/test/NightlyRun/test257.m
===================================================================
--- issm/trunk/test/NightlyRun/test257.m	(revision 8785)
+++ issm/trunk/test/NightlyRun/test257.m	(revision 8790)
@@ -7,5 +7,5 @@
 md.dt=1;
 md.output_frequency=1;
-md.ndt=3;
+md.ndt=4;
 
 %Set up transient
@@ -14,5 +14,5 @@
 
 md.forcings.surface_mass_balance= smb;
-md.forcings.surface_mass_balance(end+1,:)=[1 3];
+md.forcings.surface_mass_balance(end+1,:)=[1.5 3];
 md.isthermal=0;
 
@@ -21,9 +21,12 @@
 %Fields and tolerances to track changes
 field_names={'Vx1','Vy1','Vel1','Pressure1','Bed1','Surface1','Thickness1','SurfaceMassBalance1', ...
-	          'Vx2','Vy2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
-	          'Vx3','Vy3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3'};
-field_tolerances={1e-09,1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,...
-	                  1e-09,1e-09,1e-10,1e-09,1e-10,1e-10,1e-10,1e-10,...
-	                  1e-09,5e-10,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10};
+	'Vx2','Vy2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
+	'Vx3','Vy3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3', ...
+	'Vx4','Vy4','Vel4','Pressure4','Bed4','Surface4','Thickness4','SurfaceMassBalance4'};
+field_tolerances={1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,...
+	1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,...
+	1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,...
+	1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10};
+
 field_values={...
 	PatchToVec(md.results.TransientSolution(1).Vx),...
@@ -51,3 +54,11 @@
 	PatchToVec(md.results.TransientSolution(3).Thickness),...
 	PatchToVec(md.results.TransientSolution(3).SurfaceMassBalance),...
+	PatchToVec(md.results.TransientSolution(4).Vx),...
+	PatchToVec(md.results.TransientSolution(4).Vy),...
+	PatchToVec(md.results.TransientSolution(4).Vel),...
+	PatchToVec(md.results.TransientSolution(4).Pressure),...
+	PatchToVec(md.results.TransientSolution(4).Bed),...
+	PatchToVec(md.results.TransientSolution(4).Surface),...
+	PatchToVec(md.results.TransientSolution(4).Thickness),...
+	PatchToVec(md.results.TransientSolution(4).SurfaceMassBalance),...
 	};
Index: issm/trunk/test/NightlyRun/test258.m
===================================================================
--- issm/trunk/test/NightlyRun/test258.m	(revision 8785)
+++ issm/trunk/test/NightlyRun/test258.m	(revision 8790)
@@ -7,5 +7,5 @@
 md.dt=1;
 md.output_frequency=1;
-md.ndt=3;
+md.ndt=4;
 
 %Set up transient
@@ -14,5 +14,5 @@
 
 md.forcings.surface_mass_balance= smb;
-md.forcings.surface_mass_balance(end+1,:)=[1 3];
+md.forcings.surface_mass_balance(end+1,:)=[1.5 3];
 md.isthermal=0;
 
@@ -21,9 +21,12 @@
 %Fields and tolerances to track changes
 field_names={'Vx1','Vy1','Vel1','Pressure1','Bed1','Surface1','Thickness1','SurfaceMassBalance1', ...
-	          'Vx2','Vy2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
-	          'Vx3','Vy3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3'};
-field_tolerances={1e-09,1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,...
-	                  1e-09,1e-09,1e-10,1e-09,1e-10,1e-10,1e-10,1e-10,...
-	                  1e-09,5e-10,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10};
+	'Vx2','Vy2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
+	'Vx3','Vy3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3', ...
+	'Vx4','Vy4','Vel4','Pressure4','Bed4','Surface4','Thickness4','SurfaceMassBalance4'};
+field_tolerances={1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,...
+	1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,...
+	1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,...
+	1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10};
+
 field_values={...
 	PatchToVec(md.results.TransientSolution(1).Vx),...
@@ -51,3 +54,11 @@
 	PatchToVec(md.results.TransientSolution(3).Thickness),...
 	PatchToVec(md.results.TransientSolution(3).SurfaceMassBalance),...
+	PatchToVec(md.results.TransientSolution(4).Vx),...
+	PatchToVec(md.results.TransientSolution(4).Vy),...
+	PatchToVec(md.results.TransientSolution(4).Vel),...
+	PatchToVec(md.results.TransientSolution(4).Pressure),...
+	PatchToVec(md.results.TransientSolution(4).Bed),...
+	PatchToVec(md.results.TransientSolution(4).Surface),...
+	PatchToVec(md.results.TransientSolution(4).Thickness),...
+	PatchToVec(md.results.TransientSolution(4).SurfaceMassBalance),...
 	};
Index: issm/trunk/test/NightlyRun/test259.m
===================================================================
--- issm/trunk/test/NightlyRun/test259.m	(revision 8785)
+++ issm/trunk/test/NightlyRun/test259.m	(revision 8790)
@@ -8,5 +8,5 @@
 md.dt=1;
 md.output_frequency=1;
-md.ndt=3;
+md.ndt=4;
 
 %Set up transient
@@ -15,5 +15,5 @@
 
 md.forcings.surface_mass_balance= smb;
-md.forcings.surface_mass_balance(end+1,:)=[1 3];
+md.forcings.surface_mass_balance(end+1,:)=[1.5 3];
 md.isthermal=0;
 
@@ -22,7 +22,12 @@
 %Fields and tolerances to track changes
 field_names     ={'Vx1','Vy1','Vz1','Vel1','Pressure1','Bed1','Surface1','Thickness1','SurfaceMassBalance1', ...
-				      'Vx2','Vy2','Vz2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
-					   'Vx3','Vy3','Vz3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3'};
-field_tolerances={1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13};
+	'Vx2','Vy2','Vz2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
+	'Vx3','Vy3','Vz3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3',...
+	'Vx4','Vy4','Vz4','Vel4','Pressure4','Bed4','Surface4','Thickness4','SurfaceMassbalance4'};
+field_tolerances={1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13};
+
 field_values={...
 	PatchToVec(md.results.TransientSolution(1).Vx),...
@@ -53,3 +58,12 @@
 	PatchToVec(md.results.TransientSolution(3).Thickness),...
 	PatchToVec(md.results.TransientSolution(3).SurfaceMassBalance),...
+	PatchToVec(md.results.TransientSolution(4).Vx),...
+	PatchToVec(md.results.TransientSolution(4).Vy),...
+	PatchToVec(md.results.TransientSolution(4).Vz),...
+	PatchToVec(md.results.TransientSolution(4).Vel),...
+	PatchToVec(md.results.TransientSolution(4).Pressure),...
+	PatchToVec(md.results.TransientSolution(4).Bed),...
+	PatchToVec(md.results.TransientSolution(4).Surface),...
+	PatchToVec(md.results.TransientSolution(4).Thickness),...
+	PatchToVec(md.results.TransientSolution(4).SurfaceMassBalance),...
 	};
Index: issm/trunk/test/NightlyRun/test260.m
===================================================================
--- issm/trunk/test/NightlyRun/test260.m	(revision 8785)
+++ issm/trunk/test/NightlyRun/test260.m	(revision 8790)
@@ -8,5 +8,5 @@
 md.dt=1;
 md.output_frequency=1;
-md.ndt=3;
+md.ndt=4;
 
 %Set up transient
@@ -15,5 +15,5 @@
 
 md.forcings.surface_mass_balance= smb;
-md.forcings.surface_mass_balance(end+1,:)=[1 3];
+md.forcings.surface_mass_balance(end+1,:)=[1.5 3];
 md.isthermal=0;
 
@@ -22,7 +22,12 @@
 %Fields and tolerances to track changes
 field_names     ={'Vx1','Vy1','Vz1','Vel1','Pressure1','Bed1','Surface1','Thickness1','SurfaceMassBalance1', ...
-				      'Vx2','Vy2','Vz2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
-					   'Vx3','Vy3','Vz3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3'};
-field_tolerances={1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13};
+	'Vx2','Vy2','Vz2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
+	'Vx3','Vy3','Vz3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3',...
+	'Vx4','Vy4','Vz4','Vel4','Pressure4','Bed4','Surface4','Thickness4','SurfaceMassbalance4'};
+field_tolerances={1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13};
+
 field_values={...
 	PatchToVec(md.results.TransientSolution(1).Vx),...
@@ -53,3 +58,12 @@
 	PatchToVec(md.results.TransientSolution(3).Thickness),...
 	PatchToVec(md.results.TransientSolution(3).SurfaceMassBalance),...
+	PatchToVec(md.results.TransientSolution(4).Vx),...
+	PatchToVec(md.results.TransientSolution(4).Vy),...
+	PatchToVec(md.results.TransientSolution(4).Vz),...
+	PatchToVec(md.results.TransientSolution(4).Vel),...
+	PatchToVec(md.results.TransientSolution(4).Pressure),...
+	PatchToVec(md.results.TransientSolution(4).Bed),...
+	PatchToVec(md.results.TransientSolution(4).Surface),...
+	PatchToVec(md.results.TransientSolution(4).Thickness),...
+	PatchToVec(md.results.TransientSolution(4).SurfaceMassBalance),...
 	};
Index: issm/trunk/test/NightlyRun/test261.m
===================================================================
--- issm/trunk/test/NightlyRun/test261.m	(revision 8785)
+++ issm/trunk/test/NightlyRun/test261.m	(revision 8790)
@@ -8,5 +8,5 @@
 md.dt=1;
 md.output_frequency=1;
-md.ndt=3;
+md.ndt=4;
 
 %Set up transient
@@ -15,5 +15,5 @@
 
 md.forcings.surface_mass_balance= smb;
-md.forcings.surface_mass_balance(end+1,:)=[1 3];
+md.forcings.surface_mass_balance(end+1,:)=[1.5 3];
 md.isthermal=0;
 
@@ -22,7 +22,12 @@
 %Fields and tolerances to track changes
 field_names     ={'Vx1','Vy1','Vz1','Vel1','Pressure1','Bed1','Surface1','Thickness1','SurfaceMassBalance1', ...
-				      'Vx2','Vy2','Vz2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
-					   'Vx3','Vy3','Vz3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3'};
-field_tolerances={1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13};
+	'Vx2','Vy2','Vz2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
+	'Vx3','Vy3','Vz3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3',...
+	'Vx4','Vy4','Vz4','Vel4','Pressure4','Bed4','Surface4','Thickness4','SurfaceMassbalance4'};
+field_tolerances={1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13};
+
 field_values={...
 	PatchToVec(md.results.TransientSolution(1).Vx),...
@@ -53,3 +58,12 @@
 	PatchToVec(md.results.TransientSolution(3).Thickness),...
 	PatchToVec(md.results.TransientSolution(3).SurfaceMassBalance),...
+	PatchToVec(md.results.TransientSolution(4).Vx),...
+	PatchToVec(md.results.TransientSolution(4).Vy),...
+	PatchToVec(md.results.TransientSolution(4).Vz),...
+	PatchToVec(md.results.TransientSolution(4).Vel),...
+	PatchToVec(md.results.TransientSolution(4).Pressure),...
+	PatchToVec(md.results.TransientSolution(4).Bed),...
+	PatchToVec(md.results.TransientSolution(4).Surface),...
+	PatchToVec(md.results.TransientSolution(4).Thickness),...
+	PatchToVec(md.results.TransientSolution(4).SurfaceMassBalance),...
 	};
Index: issm/trunk/test/NightlyRun/test262.m
===================================================================
--- issm/trunk/test/NightlyRun/test262.m	(revision 8785)
+++ issm/trunk/test/NightlyRun/test262.m	(revision 8790)
@@ -8,5 +8,5 @@
 md.dt=1;
 md.output_frequency=1;
-md.ndt=3;
+md.ndt=4;
 
 %Set up transient
@@ -15,5 +15,5 @@
 
 md.forcings.surface_mass_balance= smb;
-md.forcings.surface_mass_balance(end+1,:)=[1 3];
+md.forcings.surface_mass_balance(end+1,:)=[1.5 3];
 md.isthermal=0;
 
@@ -22,7 +22,12 @@
 %Fields and tolerances to track changes
 field_names     ={'Vx1','Vy1','Vz1','Vel1','Pressure1','Bed1','Surface1','Thickness1','SurfaceMassBalance1', ...
-				      'Vx2','Vy2','Vz2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
-					   'Vx3','Vy3','Vz3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3'};
-field_tolerances={1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13};
+	'Vx2','Vy2','Vz2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SurfaceMassBalance2', ...
+	'Vx3','Vy3','Vz3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SurfaceMassBalance3',...
+	'Vx4','Vy4','Vz4','Vel4','Pressure4','Bed4','Surface4','Thickness4','SurfaceMassbalance4'};
+field_tolerances={1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13};
+
 field_values={...
 	PatchToVec(md.results.TransientSolution(1).Vx),...
@@ -53,3 +58,12 @@
 	PatchToVec(md.results.TransientSolution(3).Thickness),...
 	PatchToVec(md.results.TransientSolution(3).SurfaceMassBalance),...
+	PatchToVec(md.results.TransientSolution(4).Vx),...
+	PatchToVec(md.results.TransientSolution(4).Vy),...
+	PatchToVec(md.results.TransientSolution(4).Vz),...
+	PatchToVec(md.results.TransientSolution(4).Vel),...
+	PatchToVec(md.results.TransientSolution(4).Pressure),...
+	PatchToVec(md.results.TransientSolution(4).Bed),...
+	PatchToVec(md.results.TransientSolution(4).Surface),...
+	PatchToVec(md.results.TransientSolution(4).Thickness),...
+	PatchToVec(md.results.TransientSolution(4).SurfaceMassBalance),...
 	};